#
# shinGETsu - P2P anonymous BBS
#
# (c) Fuktommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: Node.pm,v 1.14 2004/04/28 04:50:10 fuktommy Exp $
#

package Shingetsu::Node;
use Shingetsu::Config;
use Shingetsu::Extern;
use Shingetsu::Util;

#
# constructor
# args: node-string
#	host, port, path
#
sub new($$;$$) {
	my($this, $host, $port, $path);
	if (@_ == 2) {
		$_[1] =~ m|([^:]+):(\d+)(.*)|;
		($host, $port, $path) = ($1, $2, $3);
	} elsif (@_ == 4) {
		($this, $host, $port, $path) = @_;
	} else {
		return undef;
	}
	$path =~ s|\+|/|g;
	$path = "/" if ($path eq "");
	$this = { host => $host,
		  port => $port,
		  path => $path,
		};
	return bless $this;
}

#
# connect other node
# args: message
sub talk($$) {
	my($this, $message) = @_;
	my($host, $port, $path) = ($$this{host}, $$this{port}, $$this{path});
	local $_;
	$message =~ s|^[/?]||;
	if ($path =~ m|[/?]$|) {
		$path .= $message;
	} else {
		$path .= "/$message";
	}
	my @buf = Shingetsu::Util::wget("http://$host:$port$path");
	my $gzip;
	while ((@buf>0) && ($buf[0] !~ /^\s*$/)) {
		$_ = shift @buf;
		$gzip = 1 if (/Content-Encoding:\s*gzip/i);
	}
	return () unless (@buf);
	shift @buf;
	return () unless (@buf);
	if ($gzip) {
		@buf = Shingetsu::Extern::xgunzip(@buf);
	}
	pop @buf if ($buf[-1] !~ /\n$/);
	s/[\n\r]//g foreach (@buf);
	return @buf;
}

#
# to string
#
sub toString($) {
	my($this) = @_;
	my($host, $port, $path) = ($$this{host}, $$this{port}, $$this{path});
	return "$host:$port$path";
}

#
# to +string
#
sub toXString($) {
	my($this) = @_;
	my($host, $port, $path) = ($$this{host}, $$this{port}, $$this{path});
	$path =~ s|/|+|;
	return "$host:$port$path";
}

#
# ping node
#
sub ping($) {
	my($this) = @_;
	my @buf = $this->talk("/ping");
	return ((defined $buf[0])&&($buf[0] eq "PONG"));
}

#
# connect
#
sub join($) {
	my($this) = @_;
	my $port = $ENV{SERVER_PORT};
	my $path = $Shingetsu::Config::path;
	$path =~ s|/|+|g;
	my @buf = $this->talk("/join/$ENV{SERVER_NAME}:$port$path");
	return @buf;
}

#
# unconnect
#
sub bye($) {
	my($this) = @_;
	my $port = $ENV{SERVER_PORT};
	my $path = $Shingetsu::Config::path;
	$path =~ s|/|+|g;
	my @buf = $this->talk("/bye/:$port$path");
	return (@buf > 0) && ($buf[0] eq "BYEBYE");
}

1;
